"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

var _Tag = _interopRequireDefault(require("./Tag"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * The ArduinoTags model module.
 * @module model/ArduinoTags
 * @version 1.4.1
 */
var ArduinoTags = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>ArduinoTags</code>.
   * ArduinoTags media type (default view)
   * @alias module:model/ArduinoTags
   * @param tags {Array.<module:model/Tag>} 
   */
  function ArduinoTags(tags) {
    _classCallCheck(this, ArduinoTags);

    ArduinoTags.initialize(this, tags);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(ArduinoTags, null, [{
    key: "initialize",
    value: function initialize(obj, tags) {
      obj['tags'] = tags;
    }
    /**
     * Constructs a <code>ArduinoTags</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/ArduinoTags} obj Optional instance to populate.
     * @return {module:model/ArduinoTags} The populated <code>ArduinoTags</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new ArduinoTags();

        if (data.hasOwnProperty('tags')) {
          obj['tags'] = _ApiClient["default"].convertToType(data['tags'], [_Tag["default"]]);
        }
      }

      return obj;
    }
  }]);

  return ArduinoTags;
}();
/**
 * @member {Array.<module:model/Tag>} tags
 */


ArduinoTags.prototype['tags'] = undefined;
var _default = ArduinoTags;
exports["default"] = _default;