"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ApiClient = _interopRequireDefault(require("../ApiClient"));

var _Property = _interopRequireDefault(require("./Property"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * The ThingUpdate model module.
 * @module model/ThingUpdate
 * @version 1.4.1
 */
var ThingUpdate = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>ThingUpdate</code>.
   * Payload to update an existing thing
   * @alias module:model/ThingUpdate
   */
  function ThingUpdate() {
    _classCallCheck(this, ThingUpdate);

    ThingUpdate.initialize(this);
  }
  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */


  _createClass(ThingUpdate, null, [{
    key: "initialize",
    value: function initialize(obj) {}
    /**
     * Constructs a <code>ThingUpdate</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/ThingUpdate} obj Optional instance to populate.
     * @return {module:model/ThingUpdate} The populated <code>ThingUpdate</code> instance.
     */

  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new ThingUpdate();

        if (data.hasOwnProperty('device_id')) {
          obj['device_id'] = _ApiClient["default"].convertToType(data['device_id'], 'String');
        }

        if (data.hasOwnProperty('id')) {
          obj['id'] = _ApiClient["default"].convertToType(data['id'], 'String');
        }

        if (data.hasOwnProperty('name')) {
          obj['name'] = _ApiClient["default"].convertToType(data['name'], 'String');
        }

        if (data.hasOwnProperty('properties')) {
          obj['properties'] = _ApiClient["default"].convertToType(data['properties'], [_Property["default"]]);
        }

        if (data.hasOwnProperty('timezone')) {
          obj['timezone'] = _ApiClient["default"].convertToType(data['timezone'], 'String');
        }

        if (data.hasOwnProperty('webhook_active')) {
          obj['webhook_active'] = _ApiClient["default"].convertToType(data['webhook_active'], 'Boolean');
        }

        if (data.hasOwnProperty('webhook_uri')) {
          obj['webhook_uri'] = _ApiClient["default"].convertToType(data['webhook_uri'], 'String');
        }
      }

      return obj;
    }
  }]);

  return ThingUpdate;
}();
/**
 * The arn of the associated device
 * @member {String} device_id
 */


ThingUpdate.prototype['device_id'] = undefined;
/**
 * The id of the thing
 * @member {String} id
 */

ThingUpdate.prototype['id'] = undefined;
/**
 * The friendly name of the thing
 * @member {String} name
 */

ThingUpdate.prototype['name'] = undefined;
/**
 * The properties of the thing
 * @member {Array.<module:model/Property>} properties
 */

ThingUpdate.prototype['properties'] = undefined;
/**
 * A time zone name. Check /v2/timezones for a list of valid names.
 * @member {String} timezone
 */

ThingUpdate.prototype['timezone'] = undefined;
/**
 * Webhook uri
 * @member {Boolean} webhook_active
 */

ThingUpdate.prototype['webhook_active'] = undefined;
/**
 * Webhook uri
 * @member {String} webhook_uri
 */

ThingUpdate.prototype['webhook_uri'] = undefined;
var _default = ThingUpdate;
exports["default"] = _default;